YANG Groupings for UDP Clients and UDP Servers
Alex Huang Feng
INSA-Lyon
Lyon
France
alex.huang-feng@insa-lyon.fr
Pierre Francois
INSA-Lyon
Lyon
France
pierre.francois@insa-lyon.fr
Kent Watsen
Watsen Networks
kent+ietf@watsen.net
17 October 2024
This document defines two YANG 1.1 modules to support the configuration of UDP clients and UDP servers.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Introduction
This document defines two YANG 1.1 [RFC7950] modules to support the configuration of UDP clients and UDP servers [RFC768]. The data models defined by these modules may be used directly (e.g., to define a specific UDP client or UDP server) or in conjunction with the configuration defined for higher level protocols that depend on UDP.

The "ietf-udp-client" Module
This section defines a YANG 1.1 module called "ietf-udp-client". This YANG module defines the "udp-client" grouping for configuring UDP clients with remote server information.
Section 2.1 provides an overview of the YANG module for configuring UDP clients. An example of usage is illustrated in Section 2.2 and Section 2.3 defines the YANG module itself.

Data Model Overview
This section provides an overview of the features and the grouping defined in the "ietf-udp-client" YANG module.

Features
The "ietf-udp-client" module defines only one "feature" statements:

Features:
  +-- local-binding

This "local-binding" feature indicates that the client supports configuring local bindings (i.e., the local address and local port) for UDP clients.
The diagram above uses syntax that is similar to but not defined in [RFC8340].

The "udp-client" Grouping
The following tree diagram [RFC8340] illustrates the tree structure of the "udp-client" grouping:

module: ietf-udp-client

  grouping udp-client:
    +-- remote-address    inet:host
    +-- remote-port?      inet:port-number
    +-- local-address?    inet:ip-address {local-binding}?
    +-- local-port?       inet:port-number {local-binding}?

Comments:
- The "remote-address", which is mandatory, may be configured as an IPv4 address, an IPv6 address, or a hostname.
- The "remote-port" is defined with neither a "default" nor a "mandatory" statement. YANG modules using this grouping SHOULD refine the grouping with a "default" statement, when the port number is well-known (e.g., a port number allocated by IANA), or with a "mandatory" statement, if a port number needs to always be configured. This MAY be ignored when the port number is neither well-known nor mandatory to configure, such as might be the case when this grouping is used by another grouping.
- The "local-address", which is enabled by the "local-binding" feature, may be configured as an IPv4 address, an IPv6 address, or a wildcard value.
- The "local-port", which is enabled by the "local-binding" feature, is not mandatory. Its default value is "0", indicating that the operating system can pick an arbitrary port number.

Example Usage
This section presents an example of usage of the "udp-client" grouping.

<!-- The outermost element below doesn't exist in the data model. -->
<!--  It simulates if the "grouping" were a "container" instead.  -->

<udp-client xmlns="urn:ietf:params:xml:ns:yang:ietf-udp-client">
  <remote-address>www.example.com</remote-address>
  <remote-port>10000</remote-port>
  <local-address>192.0.2.2</local-address>
  <local-port>12345</local-port>
</udp-client>

YANG Module
This module imports types defined in [RFC6991].

module ietf-udp-client {
  yang-version 1.1;
  namespace
    "urn:ietf:params:xml:ns:yang:ietf-udp-client";
  prefix udpc;
  import ietf-inet-types {
    prefix inet;
    reference
      "RFC 6991: Common YANG Data Types";
  }

  organization "IETF NETCONF (Network Configuration) Working Group";
  contact
    "WG Web:   <http:/tools.ietf.org/wg/netconf/>
     WG List:  <mailto:netconf@ietf.org>

     Authors:  Alex Huang Feng
               <mailto:alex.huang-feng@insa-lyon.fr>
               Pierre Francois
               <mailto:pierre.francois@insa-lyon.fr>";

  description
    "Defines a generic grouping for UDP-based client applications.

    Copyright (c) 2024 IETF Trust and the persons identified as
    authors of the code.  All rights reserved.

    Redistribution and use in source and binary forms, with or without
    modification, is permitted pursuant to, and subject to the license
    terms contained in, the Revised BSD License set forth in Section
    4.c of the IETF Trust's Legal Provisions Relating to IETF Documents
    (https://trustee.ietf.org/license-info).

    This version of this YANG module is part of RFC-to-be; see the RFC
    itself for full legal notices.";

  revision 2024-10-15 {
    description
      "Initial revision";
    reference
      "RFC-to-be: YANG Groupings for UDP Clients and UDP Servers";
  }

  feature local-binding {
    description
      "Indicates that the UDP client supports configuring local
       bindings (i.e., the local address and local port) for
       UDP clients.";
  }

  grouping udp-client {
    description
      "A reusable grouping for configuring a UDP client.

      Note that this grouping uses fairly typical descendant
      node names such that a stack of 'uses' statements will
      have name conflicts.  It is intended that the consuming
      data model will resolve the issue (e.g., by wrapping
      the 'uses' statement in a container called
      'udp-client-parameters').  This model purposely does
      not do this itself so as to provide maximum flexibility
      to consuming models.";

    leaf remote-address {
      type inet:host;
      mandatory true;
      description
        "The IP address or hostname of the remote UDP server.
        If a domain name is configured, then the DNS resolution should
        happen on each connection attempt. If the DNS resolution
        results in multiple IP addresses, the IP addresses
        are tried according to local preference order until
        a connection has been established or until all IP
        addresses have failed.";
    }

    leaf remote-port {
      type inet:port-number;
      description
        "The port number of the remote UDP server.";
    }

    leaf local-address {
      if-feature "local-binding";
      type inet:ip-address;
      description
        "The local IP address to bind to when sending UDP
        messages to the remote server. INADDR_ANY ('0.0.0.0') or
        INADDR6_ANY ('0:0:0:0:0:0:0:0' a.k.a. '::') may be used
        so that the server can bind to any IPv4 or IPv6 address.";
    }

    leaf local-port {
      if-feature "local-binding";
      type inet:port-number;
      default "0";
      description
        "The local port number to bind to when sending UDP
        messages to the remote server. The port number '0',
        which is the default value, indicates that any available
        local port number may be used.";
    }
  }
}

The "ietf-udp-server" Module
This section defines a YANG 1.1 module called "ietf-udp-server". This YANG module defines the "udp-server" grouping for configuring UDP servers.
Section 3.1 provides an overview of the YANG module for configuring UDP servers. An example of usage is illustrated in Section 3.2 while Section 3.3 defines the YANG module itself.

Data Model Overview
This section provides an overview of the grouping defined in the "ietf-udp-server" module.

The "udp-server" Grouping
The following tree diagram [RFC8340] illustrates the structure of "udp-server" grouping:

module: ietf-udp-server

  grouping udp-server:
    +-- local-bind* [local-address]
       +-- local-address    inet:ip-address
       +-- local-port?      inet:port-number

Comments:
- The "local-address", which is mandatory, may be configured as an IPv4 address, an IPv6 address, or a wildcard value.
- The "local-port" is defined with neither a "default" nor a "mandatory" statement. YANG modules using this grouping SHOULD refine the grouping with a "default" statement, when the port number is well-known (e.g., a port number allocated by IANA), or with a "mandatory" statement, if a port number needs to always be configured. This MAY be ignored when the port number is neither well-known nor mandatory to configure, such as might be the case when this grouping is used by another grouping.

Example Usage
This section presents two examples of usage of the "udp-server" grouping.
This following shows an example of a server configured for listening to an IPv4 address:

<!-- The outermost element below doesn't exist in the data model. -->
<!--  It simulates if the "grouping" were a "container" instead.  -->

<udp-server xmlns="urn:ietf:params:xml:ns:yang:ietf-udp-server">
  <local-bind>
    <local-address>192.0.2.2</local-address>
    <local-port>49152</local-port>
  </local-bind>
</udp-server>

This example shows an example of a server configured to listen to an IPv4 and IPv6 together:

<!-- The outermost element below doesn't exist in the data model. -->
<!--  It simulates if the "grouping" were a "container" instead.  -->

<udp-server xmlns="urn:ietf:params:xml:ns:yang:ietf-udp-server">
  <local-bind>
    <local-address>192.0.2.2</local-address>
    <local-port>49152</local-port>
  </local-bind>
  <local-bind>
    <local-address>2001:db8::0</local-address>
    <local-port>49153</local-port>
  </local-bind>
</udp-server>

YANG Module
The "ietf-udp-server" imports types defined in [RFC6991].

module ietf-udp-server {
  yang-version 1.1;
  namespace "urn:ietf:params:xml:ns:yang:ietf-udp-server";
  prefix udps;

  import ietf-inet-types {
    prefix inet;
    reference
      "RFC 6991: Common YANG Data Types";
  }

  organization
    "IETF NETCONF (Network Configuration) Working Group";
  contact
    "WG Web:   <http:/tools.ietf.org/wg/netconf/>
     WG List:  <mailto:netconf@ietf.org>

     Authors:  Alex Huang Feng
               <mailto:alex.huang-feng@insa-lyon.fr>
               Pierre Francois
               <mailto:pierre.francois@insa-lyon.fr>";
  description
    "Defines a generic grouping for UDP-based server applications.

     Copyright (c) 2024 IETF Trust and the persons identified as
     authors of the code.  All rights reserved.

     Redistribution and use in source and binary forms, with or without
     modification, is permitted pursuant to, and subject to the license
     terms contained in, the Revised BSD License set forth in Section
     4.c of the IETF Trust's Legal Provisions Relating to IETF Documents
     (https://trustee.ietf.org/license-info).

     This version of this YANG module is part of RFC-to-be; see the RFC
     itself for full legal notices.";

  revision 2024-10-15 {
    description
      "Initial revision";
    reference
      "RFC-to-be: YANG Groupings for UDP Clients and UDP Servers";
  }

  grouping udp-server {
    description
      "Provides a reusable grouping for configuring a UDP server.

       Note that this grouping uses fairly typical descendant
       node names such that a stack of 'uses' statements will
       have name conflicts.  It is intended that the consuming
       data model will resolve the issue (e.g., by wrapping
       the 'uses' statement in a container called
       'udp-server-parameters').  This model purposely does
       not do this itself so as to provide maximum flexibility
       to consuming models.";
    list local-bind {
      key "local-address";
      min-elements 1;
      description
        "A list of bind (listen) points for this server
         instance.  A server instance may have multiple
         bind points to support, e.g., the same port in
         different address families or different ports
         in the same address family.";
      leaf local-address {
        type inet:ip-address;
        mandatory true;
        description
          "The local IP address to listen on for incoming
           UDP messages.  To configure listening
           on all IPv4 addresses the value must be '0.0.0.0'
           (INADDR_ANY).  To configure listening on all IPv6
           addresses the value must be '::' (INADDR6_ANY).";
      }
      leaf local-port {
        type inet:port-number;
        description
          "The local port number to listen on for incoming UDP
           messages.";
      }
    }
  }
}

Security Considerations
This section uses the template described in Section 3.7 of [I-D.ietf-netmod-rfc8407bis].
The YANG module specified in this document defines a schema for data that is designed to be accessed via network management protocols such as NETCONF [RFC6241] or RESTCONF [RFC8040]. These network management protocols are required to use a secure transport layer and mutual authentication, e.g., SSH [RFC6242] without the "none" authentication option, Transport Layer Security (TLS) [RFC8446] with mutual X.509 authentication, and HTTPS with HTTP authentication (Section 11 of [RFC9110]).
The Network Configuration Access Control Model (NACM) [RFC8341] provides the means to restrict access for particular NETCONF or RESTCONF users to a preconfigured subset of all available NETCONF or RESTCONF protocol operations and content.
The YANG module defines a set of identities, types, and groupings. These nodes are intended to be reused by other YANG modules. The module by itself does not expose any data nodes that are writable, data nodes that contain read-only state, or RPCs. As such, there are no additional security issues related to the YANG module that need to be considered.
Modules that use the groupings that are defined in this document should identify the corresponding security considerations. For example, reusing some of these groupings will expose privacy-related information (e.g., 'node-example').

IANA Considerations
This document describes the URIs from IETF XML Registry and the registration of a two new YANG module names

URI
IANA is requested to assign two new URIs from the IETF XML Registry. The following two URIs are suggested:

URI: urn:ietf:params:xml:ns:yang:ietf-udp-client
Registrant Contact: The IESG.
XML: N/A; the requested URI is an XML namespace.

URI: urn:ietf:params:xml:ns:yang:ietf-udp-server
Registrant Contact: The IESG.
XML: N/A; the requested URI is an XML namespace.

YANG module name
This document also requests IANA to register the following YANG modules in the YANG Module Names registry within the "YANG Parameters" registry group:

name: ietf-udp-client
namespace: urn:ietf:params:xml:ns:yang:ietf-udp-client
prefix: udpc
maintained by IANA? N
reference: RFC-to-be

name: ietf-udp-server
namespace: urn:ietf:params:xml:ns:yang:ietf-udp-server
prefix: udps
maintained by IANA? N
reference: RFC-to-be

Acknowledgements
The authors would like to thank Mohamed Boucadair, Benoit Claise, Qiufang Ma and Qin Wu for their review and valuable comments.

Normative References

Informative References
[RFC2119]
[RFC8174]
[RFC7950]
[RFC768]
[RFC8340]
[RFC6991]
[I-D.ietf-netmod-rfc8407bis]
[RFC6241]
[RFC8040]
[RFC6242]
[RFC8446]
[RFC9110]
[RFC8341]